#include <stdio.h>

#define ROWS 8

void read_input(int buffer[]) {
	int i;
	
	printf("Enter input\n");
	for (i = 0; i < ROWS; i++) {
		scanf("%d", &buffer[i]);
	}
}

void print_array(int buffer[]) {
	int i;
	
	printf("Data:\n");
	for (i = 0; i < ROWS; i++) {
		printf("%d\n", buffer[i]);
	}
}

void swap (int *num1, int *num2) {
	int temp;
	temp = *num1;
	*num1 = *num2;
	*num2 = temp;
}

void selection_sort(int buffer[]) {
	int pos, min_pos, i;
	
	for (pos = 0; pos < ROWS-1; pos++) {
		min_pos = pos;
		for (i = pos+1; i < ROWS; i++) {
			if (buffer[i] < buffer[min_pos]) {
				min_pos = i;
			}
		}
		if (pos != min_pos) {
			swap(&buffer[pos], &buffer[min_pos]);
		}
	}
}

int linear_search(int buffer[], int elem, int array_size) {
	int i;
	
	for (i = 0; (i < array_size) && (elem>=buffer[i]); i++) {
		if (elem == buffer[i])
			return(i);
		/* If we know the array is sorted and we have reached a 
		 * position with an element larger than what we are looking
		 * for, we know that the element we are looking for does not
		 * exist, so we can terminate early */
		else if (buffer[i] > elem) {
			return(-1);
		}
	}
	/* We reached the end of the array and we did not find the element */
	return(-1);
}

int main (int argc, char *argv[]) {
	int data[ROWS];
	int search_elem, pos;
	
	read_input(data);
	print_array(data);

	selection_sort(data);

	print_array(data);
	
	printf("Element to look for:\n");
	scanf("%d", &search_elem);
	
	pos = linear_search(data, search_elem, ROWS);
	
	if (pos != -1) {
		printf("Element %d found at position %d\n", search_elem, pos);
	}
	else {
		printf("Element %d not found\n", search_elem);
	}
	
	return(0);
}
